﻿Public Class frmDemoVfd2002
    '
    '   (C)Copyright by Techno Veins Co.,Ltd.
    '   All right reserved. 2014
    '

    '
    '   このプログラムの著作権はテクノベインズが保有します。
    '   直接ソースの全部または一部を販売することは禁止します。
    '   ソースの全部または一部を再配布や書籍・Web等への許可なき転載は禁止します。
    '
    '   お客様が行う独自開発プログラムへソースの組込使用について、自由に参考利用していただいてかまいません。(費用・登録等不要。)
    '   VFD2002E販売の際、商品に添付して配布することはご自由に行ってください。
    '
    '
    '   本プログラムは参考用であり、すべてのお客様の環境で動作を保証するものではありません｡
    '   特に、実用のプログラムに組み込む場合、さらなるエラー処理等を組み込んでください。
    '   また、本プログラムを用いることで、何らかの不利益が発生した場合であっても、テクノベインズでは一切の保証を行いません。
    '
    '   説明のために1行で記述できる行も分解して記述している部分があります。
    '
    '
    '   変更履歴
    '
    '		Apr.22.2014    Ver 1.00	Naoya Takaku : VB2014	
    '

    Dim MsgCount As Integer = 0     '表示内容更新用カウンタ


    '
    '   フォーム開始時の初期化処理
    '
    Private Sub frmDemoVfd2002_Shown(sender As Object, e As EventArgs) Handles Me.Shown
        Dim CheckPort As Boolean = False


        'My.Settingsに保存されている通信ポート名の初期値を取得する。ループで使用するために一旦Stringに入れている。
        Dim prevComPort As String = My.Settings.iniComPort.Trim.ToUpper


        '  For Each文で、実行時に登録されている全てのComポート名を取得する。
        '  My.computerを使用して、SerialPort名一覧を取得
        For Each portName As String In My.Computer.Ports.SerialPortNames

            '   見つかったCOMポート名称のComboBox1への登録
            cmbComPort.Items.Add(portName)

            '  ポート名が保存されており、最終保存名と同じポートが存在するか？
            If prevComPort.Length > 0 AndAlso portName = prevComPort Then CheckPort = True

        Next

        '   全てのポートを取得後、登録されているポート名は現在でも有効であるか？
        If CheckPort Then

            '   有効であるため、保存されているポート名を使用する
            serPort.PortName = prevComPort
            cmbComPort.Text = prevComPort

        Else
            '   ポート名が確定していない場合、最初のポートを初期ポートとする
            ' Tips:cmbComPortのプログラムからの選択は.SelectedIndexで行い、先頭のインデックスは0
            If cmbComPort.Items.Count > 0 Then
                cmbComPort.SelectedIndex = 0
            Else
                MsgBox("シリアルポートが見つかりません。", MsgBoxStyle.Critical)
            End If
        End If

        '   シリアルポート送信データの文字エンコードを指定する。
        serPort.Encoding = System.Text.Encoding.GetEncoding(932)    ' SJISエンコーディング


    End Sub

    '
    '   フォーム終了要求
    '
    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub


    '
    '   VFD2002Eへのシリアル送信
    '

    Private Sub SendVfd(ByVal mesTxtUpper As String, ByVal mesTxtLower As String)

        SendVfd(Chr(&HB) & radj(mesTxtUpper) & Chr(&HB) & Chr(&HA) & mesTxtLower)

    End Sub


    '
    '   表示用右揃え処理
    '
    Function radj(ByVal mesTxt As String) As String
        Return mesTxt.PadRight(20).Substring(0, 20)
    End Function


    '
    '   通信条件はSerialPortコントロールのプロパティにて直接代入済み
    '
    Private Sub SendVfd(ByVal mesTxt As String)
        Try

            '   この例では、シリアルポートのOpen制御を1回の送信ごとに開放している。
            '   Open処理は時間がかかるため、高速な表示速度が要求される場合、プログラム実行中は常にシリアルポートをOPEN保持する。
            '   また、レシートプリンタへの出力で、紙切れエラーが送信から遅れて受信され、データ再送が必要な場合など、
            '   複雑な動きが想定される場合、スレッドを利用してバックグラウンドジョブとして送信する方法もある。
            '   シリアルポートOpenを継続した場合、同じポートに対してはOpenできないため注意を要する。 


            '   この例では、送信タイムアウトはコントロールプロパティにて設定している
            serPort.Open()

            '   送信   serPort.EncodingプロパティによりSerialPortコントロール側でEncode処理する
            serPort.Write(mesTxt)


        Catch ex As Exception
            '   最小限のエラー処理しか行っていない。
            '   これだけでもケーブルが外れた場合などの際、タイムアウトのエラーで表示が行える。
            MsgBox("シリアル通信エラー", MsgBoxStyle.Critical)

        End Try

        '   送信バッファが空になるのを確認してClose処理を行う
        While serPort.BytesToWrite > 0
            '   必要に応じて、タイムアウト処理を組み込む（この例のままではForever戻ってきません。）
        End While

        '   ポートのクローズ
        serPort.Close()

    End Sub


    '
    '   COMポートの指定が変更された
    '
    Private Sub cmbComPort_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbComPort.SelectedIndexChanged

        Try
            '   SerialPortコントロールのPort値を変更する
            serPort.PortName = cmbComPort.Text

            ' ComboBox1.TextをMy.Settings.iniComPortにPropertyBindingで接続するか、変更があった場合手動で保存する
            My.Settings.iniComPort = cmbComPort.Text

            '   Formが終了される際にもMy.Settingsは自動的に保存されるが、ここで強制的の保存する例
            My.Settings.Save()

        Catch ex As Exception
            MsgBox("シリアルポート設定エラー", MsgBoxStyle.Critical)
        End Try
    End Sub

    '
    '   デモボタン
    '

    '   VFD2002Eハードウェア初期化
    Private Sub btnInit_Click(sender As Object, e As EventArgs) Handles btnInit.Click
        SendVfd(Chr(&H1B) & Chr(&H40))
    End Sub

    '   CLEAR SCREEN(&H0c)
    Private Sub btnCls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCls.Click
        SendVfd(Chr(&HC)) ' 画面クリアコマンドのみ送信する
        MsgCount = 0
    End Sub

    Private Sub btnDispUriage_Click(sender As Object, e As EventArgs) Handles btnDispUriage.Click


        '   表示用ダミーカウント このボタンは、押すたびに異なるメッセージがサイクルする
        ' Tips VBでも+=が使えるようになりました。
        MsgCount += 1
        MsgCount = MsgCount Mod 3

        '   画面原点移動(&HB)と文字表示(半角40文字 20桁2行分)
        '   表示データをあらかじめ構成しておき、半角４０文字として送信する
        '   画面をクリアするよりも、表示原点をホームポジションに移動して画面全てを書き換えたほうが高速に表示できる
        '   ホームポジションを入れなくとも40文字出力により毎回同じ位置に表示するが、
        '   通信エラーなど異常表示により表示がずれることを防ぐために、ホーム(&hB)を行っている

        Select Case MsgCount
            Case 0
                SendVfd("ﾄﾏﾄｹﾁｬｯﾌﾟ       \120", "ｹｲ: 3ﾃﾝ      \12,345")

            Case 1
                SendVfd("ｷｬﾍﾞﾂ           \100", "ｹｲ: 1ﾃﾝ       \5,545")

            Case Else
                SendVfd("ﾏｸﾞﾛﾌﾞﾂ       \1,500", "ｹｲ: 1ﾃﾝ      \12,545")

        End Select

    End Sub

    '   合計表示例
    Private Sub btnDispAzukari_Click(sender As Object, e As EventArgs) Handles btnDispAzukari.Click
        SendVfd("ｹｲ   10ﾃﾝ     \8,500", "ｵﾂﾘ:          \1,500")
    End Sub


End Class
